local uabStatus_MainBuffs = uabUnitStatus:NewModule("Main Buffs")

uabStatus_MainBuffs.userdefined = {}
uabStatus_MainBuffs.mixins = {}
uabStatus_MainBuffs.mixins.aura = AceLibrary("SpecialEvents-Aura-2.0")
uabStatus_MainBuffs.defaultDB = {
    disabled = nil,
    intellect = {
        disabled = nil,
        priority = 50,
        color = { r = 0, g = 0, b = 1, a = 1, },
        classfilter = {
            druid = true,
            hunter = true,
            mage = true,
            paladin = true,
            priest = true,
            rogue = nil,
            shaman = true,
            warlock = true,
            warrior = nil,
        },
	},
    fort = {
        disabled = nil,
        priority = 50,
        color = { r = 0, g = 0, b = 1, a = 1, },
        classfilter = {
            druid = true,
            hunter = true,
            mage = true,
            paladin = true,
            priest = true,
            rogue = true,
            shaman = true,
            warlock = true,
            warrior = true,
        },
	},
    shadowprot = {
        disabled = nil,
        priority = 50,
        color = { r = 0, g = 0, b = 1, a = 1, },
        classfilter = {
            druid = true,
            hunter = true,
            mage = true,
            paladin = true,
            priest = true,
            rogue = true,
            shaman = true,
            warlock = true,
            warrior = true,
        },
	},
    spirit = {
        disabled = nil,
        priority = 50,
        color = { r = 0, g = 0, b = 1, a = 1, },
        classfilter = {
            druid = true,
            hunter = true,
            mage = true,
            paladin = true,
            priest = true,
            rogue = nil,
            shaman = true,
            warlock = true,
            warrior = nil,
        },
	},
    mark = {
        disabled = nil,
        priority = 50,
        color = { r = 0, g = 0, b = 1, a = 1, },
        classfilter = {
            druid = true,
            hunter = true,
            mage = true,
            paladin = true,
            priest = true,
            rogue = true,
            shaman = true,
            warlock = true,
            warrior = true,
        },
	},
    
    userdefined = {
    },
}

uabStatus_MainBuffs.constants = {
    strings = {
        bintellect = "Buff: Arcane Intellect",
        bfort = "Buff: Fortitude",
        bshadowprot = "Buff: Shadow Protection",
        bspirit = "Buff: Divine Spirit",
        bmark = "Buff: Mark of the Wild",
    
        intellect1 = "Arcane Intellect",
        intellect2 = "Arcane Brilliance",
        fort1 = "Power Word: Fortitude",
        fort2 = "Prayer of Fortitude",
        shadowprot = "Shadow Protection",
        spirit1 = "Divine Spirit",
        spirit2 = "Prayer of Spirit",
        mark1 = "Mark of the Wild",
        mark2 = "Gift of the Wild",
    }
}

function uabStatus_MainBuffs:OnInitialize()
    self.super.OnInitialize(self)

	self:RegisterUnitStatus("Buffs", uabStatus_MainBuffs.constants.strings.bintellect)
	self:RegisterUnitStatus("Buffs", uabStatus_MainBuffs.constants.strings.bfort)
	self:RegisterUnitStatus("Buffs", uabStatus_MainBuffs.constants.strings.bshadowprot)
	self:RegisterUnitStatus("Buffs", uabStatus_MainBuffs.constants.strings.bspirit)
	self:RegisterUnitStatus("Buffs", uabStatus_MainBuffs.constants.strings.bmark)

    self:RegisterEvent("SpecialEvents_UnitBuffGained")
    self:RegisterEvent("SpecialEvents_UnitBuffLost")
    
    -- dynamically added buffs
    for name, settings in pairs(self.db.profile.userdefined) do
        self:RegisterUnitStatus("Buffs", name)
    end
end

function uabStatus_MainBuffs:SpecialEvents_UnitBuffGained(unit, buffName, index, applications, texture, rank)
    local class = self:GetUnitClass(unit)
    local hasbuff
    
	if buffName == uabStatus_MainBuffs.constants.strings.intellect1 or buffName == uabStatus_MainBuffs.constants.strings.intellect2 then
        if not class or self.db.profile.intellect.classfilter[class] then
            hasbuff = uabStatus_MainBuffs.constants.strings.bintellect
        end
	elseif buffName == uabStatus_MainBuffs.constants.strings.fort1 or buffName == uabStatus_MainBuffs.constants.strings.fort2 then
        if not class or self.db.profile.fort.classfilter[class] then
            hasbuff = uabStatus_MainBuffs.constants.strings.bfort
        end
	elseif buffName == uabStatus_MainBuffs.constants.strings.shadowprot then
        if not class or self.db.profile.shadowprot.classfilter[class] then
            hasbuff = uabStatus_MainBuffs.constants.strings.bshadowprot
        end
	elseif buffName == uabStatus_MainBuffs.constants.strings.spirit1 or buffName == uabStatus_MainBuffs.constants.strings.spirit2 then
        if not class or self.db.profile.spirit.classfilter[class] then
            hasbuff = uabStatus_MainBuffs.constants.strings.bspirit
        end
	elseif buffName == uabStatus_MainBuffs.constants.strings.mark1 or buffName == uabStatus_MainBuffs.constants.strings.mark2 then
        if not class or self.db.profile.mark.classfilter[class] then
            hasbuff = uabStatus_MainBuffs.constants.strings.bmark
        end
	end

    if not hasbuff then
        -- dynamically added buffs
        for dynname, settings in pairs(self.db.profile.userdefined) do
            if buffName == settings.name then
                if not class or settings.classfilter[class] then
                    hasbuff = dynname
                end
                break
            end
        end
    end

    if hasbuff then
        self:UnitStatusGained(hasbuff, unit)
    end
end

function uabStatus_MainBuffs:SpecialEvents_UnitBuffLost(unit, buffName, applications, texture, rank)
    local class = self:GetUnitClass(unit)
    local hasbuff
    
	if buffName == uabStatus_MainBuffs.constants.strings.intellect1 or buffName == uabStatus_MainBuffs.constants.strings.intellect2 then
        if not class or self.db.profile.intellect.classfilter[class] then
            hasbuff = uabStatus_MainBuffs.constants.strings.bintellect
        end
	elseif buffName == uabStatus_MainBuffs.constants.strings.fort1 or buffName == uabStatus_MainBuffs.constants.strings.fort2 then
        if not class or self.db.profile.fort.classfilter[class] then
            hasbuff = uabStatus_MainBuffs.constants.strings.bfort
        end
	elseif buffName == uabStatus_MainBuffs.constants.strings.shadowprot then
        if not class or self.db.profile.shadowprot.classfilter[class] then
            hasbuff = uabStatus_MainBuffs.constants.strings.bshadowprot
        end
	elseif buffName == uabStatus_MainBuffs.constants.strings.spirit1 or buffName == uabStatus_MainBuffs.constants.strings.spirit2 then
        if not class or self.db.profile.spirit.classfilter[class] then
            hasbuff = uabStatus_MainBuffs.constants.strings.bspirit
        end
	elseif buffName == uabStatus_MainBuffs.constants.strings.mark1 or buffName == uabStatus_MainBuffs.constants.strings.mark2 then
        if not class or self.db.profile.mark.classfilter[class] then
            hasbuff = uabStatus_MainBuffs.constants.strings.bmark
        end
	end

    if not hasbuff then
        -- dynamically added buffs
        for dynname, settings in pairs(self.db.profile.userdefined) do
            if buffName == settings.name then
                if not class or settings.classfilter[class] then
                    hasbuff = dynname
                end
                break
            end
        end
    end

    if hasbuff then
        self:UnitStatusLost(hasbuff, unit)
    end
end

function uabStatus_MainBuffs:OnEnable()
end

function uabStatus_MainBuffs:OnDisable()
end

function uabStatus_MainBuffs:IsStatusGained(name, unit, action)
    local class = self:GetUnitClass(unit)
    local hasbuff
    local name1, name2
    local enabled = 0
    local duration = 0
    local timeleft = 0
    
	if name == uabStatus_MainBuffs.constants.strings.bintellect then
        if not class or self.db.profile.intellect.classfilter[class] then
            name1 = uabStatus_MainBuffs.constants.strings.intellect1
            name2 = uabStatus_MainBuffs.constants.strings.intellect2
        end
	elseif name == uabStatus_MainBuffs.constants.strings.bfort then
        if not class or self.db.profile.fort.classfilter[class] then
            name1 = uabStatus_MainBuffs.constants.strings.fort1
            name2 = uabStatus_MainBuffs.constants.strings.fort2
        end
	elseif name == uabStatus_MainBuffs.constants.strings.bshadowprot then
        if not class or self.db.profile.shadowprot.classfilter[class] then
            name1 = uabStatus_MainBuffs.constants.strings.shadowprot
        end
	elseif name == uabStatus_MainBuffs.constants.strings.bspirit then
        if not class or self.db.profile.spirit.classfilter[class] then
            name1 = uabStatus_MainBuffs.constants.strings.spirit1
            name2 = uabStatus_MainBuffs.constants.strings.spirit2
        end
	elseif name == uabStatus_MainBuffs.constants.strings.bmark then
        if not class or self.db.profile.mark.classfilter[class] then
            name1 = uabStatus_MainBuffs.constants.strings.mark1
            name2 = uabStatus_MainBuffs.constants.strings.mark2
        end
	end

    if not name1 then
        -- dynamically added buffs
        for dynname, settings in pairs(self.db.profile.userdefined) do
            if name == dynname then
                if not class or settings.classfilter[class] then
                    name1 = settings.name
                end
                break
            end
        end
    end

    if name1 then        
        hasbuff = self.mixins.aura:UnitHasBuff(unit, name1) or (name2 and self.mixins.aura:UnitHasBuff(unit, name2))
        if hasbuff then
            local name, i
            
            i = 1
            while (UnitBuff(unit, i) ~= nil) do
                name, _, _, _, duration, timeleft = UnitBuff(unit, i)
                if name == name1 or (name2 and name == name2) then
                    enabled = duration and timeleft and 1
                    break
                end
                i = i + 1
            end
        end
    end

    local start = 0
    
    if enabled and enabled > 0 and duration and duration > 0 and timeleft and timeleft > 0 then
        start = (GetTime() + timeleft) - duration
    end
    
    return hasbuff, enabled, start, duration
end

function uabStatus_MainBuffs:OptionsForUnitStatus(name)
	if name == uabStatus_MainBuffs.constants.strings.bintellect then
		return self.db.profile.intellect
	elseif name == uabStatus_MainBuffs.constants.strings.bfort then
		return self.db.profile.fort
	elseif name == uabStatus_MainBuffs.constants.strings.bshadowprot then
		return self.db.profile.shadowprot
	elseif name == uabStatus_MainBuffs.constants.strings.bspirit then
		return self.db.profile.spirit
	elseif name == uabStatus_MainBuffs.constants.strings.bmark then
		return self.db.profile.mark
	end

    -- dynamically added buffs
    for dynname, settings in pairs(self.db.profile.userdefined) do
        if name == dynname then
            return settings
        end
    end
    
end

local lastorder

function uabStatus_MainBuffs:RemoveUserDefined(buffname)
    local args = self.core.core.options.args.unitstatus.args[self.name]

    args.args[buffname] = nil
    args.args.remove.args[buffname] = nil
    self.db.profile.userdefined[buffname] = nil
    self:UnregisterUnitStatus("Buffs", buffname)

    lastorder = 50
    
    -- dynamically added buffs
    for name, settings in pairs(self.db.profile.userdefined) do
        if not settings.name then
            settings.name = name
        end

        args.args[name].order = lastorder + 10
        lastorder = args.args[name].order
    end
    
    self:SetUserDefinedBuffList()
end

function uabStatus_MainBuffs:SetUserDefinedBuffList()
    for pos, _ in pairs(self.userdefined) do
        self.userdefined[pos] = nil
    end

    local pos = 1
    
    -- dynamically added buffs
    for name, settings in pairs(self.db.profile.userdefined) do
        self.userdefined[pos] = name
        pos = pos + 1
    end
end

function uabStatus_MainBuffs:CreateUnitStatusOptions()
    local args = {}

    args = {
        type = 'group',
        name = "Buffs",
        desc = "Configure the options for Buffs unit status values",
        args = {
            enabled = {
                type = 'toggle',
                name = "Enabled",
                desc = "When checked, enable the use of the Buffs unit status values",
                order = 1,
                get = function()
                    return not self.db.profile.disabled
                end,
                set = function(v)
                    self.db.profile.disabled = not v
                end,
            },

            addnew = {
                name = "Add New",
                type = 'text',
                desc = "Create a new buff",
                usage = "<name>",
                order = 30,
                get = function() return end,
                set = function(newname)
                    self.db.profile.userdefined["Buff: "..newname] = {
                        name = newname,
                        disabled = nil,
                        priority = 50,
                        color = { r = 0, g = 0, b = 1, a = 1, },
                        classfilter = {
                            druid = true,
                            hunter = true,
                            mage = true,
                            paladin = true,
                            priest = true,
                            rogue = true,
                            shaman = true,
                            warlock = true,
                            warrior = true,
                        },
                    }

                    self:RegisterUnitStatus("Buffs", "Buff: "..newname)

                    local args = self.core.core.options.args.unitstatus.args[self.name]
                                    
                    args.args["Buff: "..newname] = self:CreateUnitStatusOption(self.db.profile.userdefined["Buff: "..newname], "Buff: "..newname, "Buff: "..newname, true)
                    args.args["Buff: "..newname].order = lastorder + 10
                    lastorder = args.args["Buff: "..newname].order

                    args.args.remove.args["Buff: "..newname] = {
                        type = 'execute',
                        name = "Buff: "..newname,
                        desc = "Remove the ".."Buff: "..newname.." buff",
                        func = function()
                            self:RemoveUserDefined("Buff: "..newname)
                        end,
                    }
    
                    self:SetUserDefinedBuffList()
                end,
                validate = function(newname)
                    for name, settings in pairs(self.db.profile.userdefined) do
                        if name == "Buff: "..newname then
                            return false
                        end
                    end
                    
                    return true
                end,
                order = 2,
            },

            remove = {
                type = 'group',
                name = "Remove",
                desc = "Remove a buff",
                order = 3,
                args = {
                },
            },

            spacing3 = {
                name = " ",
                type = 'header',
                order = 5,
            },
        },
    }

    args.args.intellect = self:CreateUnitStatusOption(self.db.profile.intellect, uabStatus_MainBuffs.constants.strings.bintellect, uabStatus_MainBuffs.constants.strings.bintellect, true)
    args.args.intellect.order = 10

    args.args.fort = self:CreateUnitStatusOption(self.db.profile.fort, uabStatus_MainBuffs.constants.strings.bfort, uabStatus_MainBuffs.constants.strings.bfort, true)
    args.args.fort.order = 20

    args.args.spirit = self:CreateUnitStatusOption(self.db.profile.spirit, uabStatus_MainBuffs.constants.strings.bspirit, uabStatus_MainBuffs.constants.strings.bspirit, true)
    args.args.spirit.order = 30

    args.args.shadowprot = self:CreateUnitStatusOption(self.db.profile.shadowprot, uabStatus_MainBuffs.constants.strings.bshadowprot, uabStatus_MainBuffs.constants.strings.bshadowprot, true)
    args.args.shadowprot.order = 40

    args.args.mark = self:CreateUnitStatusOption(self.db.profile.mark, uabStatus_MainBuffs.constants.strings.bmark, uabStatus_MainBuffs.constants.strings.bmark, true)
    args.args.mark.order = 50

    lastorder = 50
    
    -- dynamically added buffs
    for name, settings in pairs(self.db.profile.userdefined) do
        if not settings.name then
            settings.name = name
        end
        
        args.args[name] = self:CreateUnitStatusOption(settings, name, name, true)
        args.args[name].order = lastorder + 10
        lastorder = args.args[name].order
    end
    
    for name, settings in pairs(self.db.profile.userdefined) do
        args.args.remove.args[name] = {
            type = 'execute',
            name = name,
            desc = "Remove the "..settings.name.." buff",
            order = 100,
            func = function()
                self:RemoveUserDefined(name)
            end,
        }
    end

    self:SetUserDefinedBuffList()
    
    return args
end

